'use strict';

var _inherits = require('babel-runtime/helpers/inherits').default;

var _classCallCheck = require('babel-runtime/helpers/class-call-check').default;

var _regeneratorRuntime = require('babel-runtime/regenerator').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _testcafeBrowserNatives = require('testcafe-browser-natives');

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

var _command = require('./command');

var _command2 = _interopRequireDefault(_command);

var LocalBrowserConnection = (function (_BrowserConnection) {
    _inherits(LocalBrowserConnection, _BrowserConnection);

    function LocalBrowserConnection(gateway, browserInfo) {
        _classCallCheck(this, LocalBrowserConnection);

        _BrowserConnection.call(this, gateway);

        this.NATIVE_ACTION_DELAY = 500;
        this.WAITING_FOR_CLOSE_TIMEOUT = 10000;

        this.forceClose = false;
        this.switchedToIdleOnClose = false;
        this.waitingForCloseTimeout = 0;

        this._runBrowser(browserInfo);
    }

    LocalBrowserConnection.prototype._runBrowser = function _runBrowser(browserInfo) {
        var _this = this;

        // NOTE: Give caller time to assign event listeners
        process.nextTick(function callee$2$0() {
            return _regeneratorRuntime.async(function callee$2$0$(context$3$0) {
                while (1) switch (context$3$0.prev = context$3$0.next) {
                    case 0:
                        context$3$0.prev = 0;
                        context$3$0.next = 3;
                        return _regeneratorRuntime.awrap(_testcafeBrowserNatives.open(browserInfo, this.url));

                    case 3:
                        context$3$0.next = 8;
                        break;

                    case 5:
                        context$3$0.prev = 5;
                        context$3$0.t0 = context$3$0['catch'](0);

                        this.emit('error', context$3$0.t0.message);

                    case 8:
                    case 'end':
                        return context$3$0.stop();
                }
            }, null, _this, [[0, 5]]);
        });
    };

    LocalBrowserConnection.prototype.close = function close() {
        var _this2 = this;

        // NOTE: When using local connections, we should close the browser before closing
        // the connection. For this, we close connections in the getStatus function.
        this.forceClose = true;

        this.waitingForCloseTimeout = setTimeout(function () {
            return _this2.emit('closed');
        }, this.WAITING_FOR_CLOSE_TIMEOUT);
    };

    LocalBrowserConnection.prototype.getStatus = function getStatus() {
        var _this3 = this;

        if (this.forceClose) {
            // NOTE: when the task is done we should redirect the browser
            // to the idle page and close it by the page url.
            if (!this.switchedToIdleOnClose) {
                this.switchedToIdleOnClose = true;

                return { cmd: _command2.default.idle, url: this.idleUrl };
            }

            setTimeout(function callee$2$0() {
                return _regeneratorRuntime.async(function callee$2$0$(context$3$0) {
                    while (1) switch (context$3$0.prev = context$3$0.next) {
                        case 0:
                            context$3$0.next = 2;
                            return _regeneratorRuntime.awrap(_testcafeBrowserNatives.close(this.idleUrl));

                        case 2:
                            _BrowserConnection.prototype.close.call(this);
                            clearTimeout(this.waitingForCloseTimeout);
                            this.emit('closed');

                        case 5:
                        case 'end':
                            return context$3$0.stop();
                    }
                }, null, _this3);
            }, this.NATIVE_ACTION_DELAY);

            return { cmd: _command2.default.close };
        }

        return _BrowserConnection.prototype.getStatus.call(this);
    };

    return LocalBrowserConnection;
})(_index2.default);

exports.default = LocalBrowserConnection;
module.exports = exports.default;