'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _tty = require('tty');

var _tty2 = _interopRequireDefault(_tty);

var _elegantSpinner = require('elegant-spinner');

var _elegantSpinner2 = _interopRequireDefault(_elegantSpinner);

var _logUpdate = require('log-update');

var _logUpdate2 = _interopRequireDefault(_logUpdate);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

// NOTE: To support piping, we use stderr as the log output
// stream, while stdout is used for the report output.
exports.default = {
    animation: null,
    isTTY: _tty2.default.isatty(1),

    showSpinner: function () {
        // NOTE: we can use the spinner only if stderr is a TTY,
        // otherwise we can't repaint animation frames
        if (this.isTTY) {
            var spinnerFrame = _elegantSpinner2.default();

            this.animation = setInterval(function () {
                var frame = _chalk2.default.cyan(spinnerFrame());

                _logUpdate2.default.stderr(frame);
            }, 50);
        }
    },

    hideSpinner: function () {
        if (this.animation) {
            clearInterval(this.animation);
            _logUpdate2.default.stderr.clear();

            this.animation = null;
        }
    },

    write: function (text) {
        console.error(text);
    }
};
module.exports = exports.default;