'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _qrcodeTerminal = require('qrcode-terminal');

var _qrcodeTerminal2 = _interopRequireDefault(_qrcodeTerminal);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _log = require('./log');

var _log2 = _interopRequireDefault(_log);

var _es6Promise = require('es6-promise');

function waitBrowserConnectionReady(browserConnection) {
    return new _es6Promise.Promise(function (resolve) {
        return browserConnection.once('ready', resolve);
    });
}

exports.default = function callee$0$0(testCafe, remoteCount, showQRCode) {
    var connections, i, browserConnection;
    return _regeneratorRuntime.async(function callee$0$0$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                connections = [];

                if (!remoteCount) {
                    context$1$0.next = 16;
                    break;
                }

                _log2.default.hideSpinner();

                i = 0;

            case 4:
                if (!(i < remoteCount)) {
                    context$1$0.next = 15;
                    break;
                }

                browserConnection = testCafe.createBrowserConnection();

                _log2.default.write('To connect a remote browser #' + (i + 1) + ', use it to open ' + _chalk2.default.underline.blue(browserConnection.url));

                if (showQRCode) {
                    _log2.default.write('or scan this QR-code:\n');
                    _qrcodeTerminal2.default.generate(browserConnection.url);
                }

                context$1$0.next = 10;
                return _regeneratorRuntime.awrap(waitBrowserConnectionReady(browserConnection));

            case 10:

                connections.push(browserConnection);
                _log2.default.write(_chalk2.default.green('CONNECTED') + ' ' + browserConnection.userAgent + '\n');

            case 12:
                i++;
                context$1$0.next = 4;
                break;

            case 15:

                _log2.default.showSpinner();

            case 16:
                return context$1$0.abrupt('return', connections);

            case 17:
            case 'end':
                return context$1$0.stop();
        }
    }, null, this);
};

module.exports = exports.default;