'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator').default;

var _Promise = require('babel-runtime/core-js/promise').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

var _interopRequireWildcard = require('babel-runtime/helpers/interop-require-wildcard').default;

exports.__esModule = true;

var _testcafe = require('./testcafe');

var _testcafe2 = _interopRequireDefault(_testcafe);

var _endpointUtils = require('endpoint-utils');

var endpointUtils = _interopRequireWildcard(_endpointUtils);

var _messages = require('./messages');

// Validations
function getValidHostname(hostname) {
    var valid;
    return _regeneratorRuntime.async(function getValidHostname$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                if (!hostname) {
                    context$1$0.next = 8;
                    break;
                }

                context$1$0.next = 3;
                return _regeneratorRuntime.awrap(endpointUtils.isMyHostname(hostname));

            case 3:
                valid = context$1$0.sent;

                if (valid) {
                    context$1$0.next = 6;
                    break;
                }

                throw new Error(_messages.getText(_messages.MESSAGE.invalidHostname, hostname));

            case 6:
                context$1$0.next = 11;
                break;

            case 8:
                context$1$0.next = 10;
                return _regeneratorRuntime.awrap(endpointUtils.getMyHostname());

            case 10:
                hostname = context$1$0.sent;

            case 11:
                return context$1$0.abrupt('return', hostname);

            case 12:
            case 'end':
                return context$1$0.stop();
        }
    }, null, this);
}

function getValidPort(port) {
    var isFree;
    return _regeneratorRuntime.async(function getValidPort$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                if (!port) {
                    context$1$0.next = 8;
                    break;
                }

                context$1$0.next = 3;
                return _regeneratorRuntime.awrap(endpointUtils.isFreePort(port));

            case 3:
                isFree = context$1$0.sent;

                if (isFree) {
                    context$1$0.next = 6;
                    break;
                }

                throw new Error(_messages.getText(_messages.MESSAGE.portIsNotFree, port));

            case 6:
                context$1$0.next = 11;
                break;

            case 8:
                context$1$0.next = 10;
                return _regeneratorRuntime.awrap(endpointUtils.getFreePort());

            case 10:
                port = context$1$0.sent;

            case 11:
                return context$1$0.abrupt('return', port);

            case 12:
            case 'end':
                return context$1$0.stop();
        }
    }, null, this);
}

// API
function createTestCafe(hostname, port1, port2) {
    var _ref;

    return _regeneratorRuntime.async(function createTestCafe$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                context$1$0.next = 2;
                return _regeneratorRuntime.awrap(_Promise.all([getValidHostname(hostname), getValidPort(port1), getValidPort(port2)]));

            case 2:
                _ref = context$1$0.sent;
                hostname = _ref[0];
                port1 = _ref[1];
                port2 = _ref[2];
                return context$1$0.abrupt('return', new _testcafe2.default(hostname, port1, port2));

            case 7:
            case 'end':
                return context$1$0.stop();
        }
    }, null, this);
}

createTestCafe.pluginTestingUtils = {};

exports.default = createTestCafe;
module.exports = exports.default;