'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;
exports.default = format;

var _parse5 = require('parse5');

var _templates = require('./templates');

var _templates2 = _interopRequireDefault(_templates);

function getSelector(node) {
    var dataTypeAttr = node.attrs.filter(function (attr) {
        return attr.name === 'data-type';
    })[0];
    var type = dataTypeAttr && dataTypeAttr.value || '';

    return type ? node.tagName + ' ' + type : node.tagName;
}

function decorateHTML(node, decorator) {
    var msg = '';

    if (node.nodeName === '#text') msg = node.value;else {
        if (node.childNodes.length) msg = node.childNodes.reduce(function (prev, childNode) {
            return prev + decorateHTML(childNode, decorator);
        }, msg);

        if (node.nodeName !== '#document-fragment') msg = decorator[getSelector(node)](msg, node.attrs);
    }

    return msg;
}

function format(err, decorator, viewportWidth) {
    var parser = new _parse5.Parser();
    var fragment = parser.parseFragment(_templates2.default[err.type](err, viewportWidth));

    return decorateHTML(fragment, decorator);
}

module.exports = exports.default;