'use strict';

var _classCallCheck = require('babel-runtime/helpers/class-call-check').default;

var _regeneratorRuntime = require('babel-runtime/regenerator').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _path = require('path');

var _es6Promisify = require('es6-promisify');

var _es6Promisify2 = _interopRequireDefault(_es6Promisify);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _testcafeBrowserNatives = require('testcafe-browser-natives');

var ensureDir = _es6Promisify2.default(_mkdirp2.default);

var Capturer = (function () {
    function Capturer(screenshotPath, testDirPath, testEntry) {
        _classCallCheck(this, Capturer);

        this.enabled = !!screenshotPath;
        this.path = screenshotPath;
        this.testDirPath = testDirPath;
        this.testEntry = testEntry;
    }

    Capturer._getFileName = function _getFileName(stepName) {
        return (stepName && stepName.replace(/\s|\\|\/|"|\*|\?|<|>|\|/g, '_') || 'Page_Load') + '.png';
    };

    Capturer.prototype._takeScreenshot = function _takeScreenshot(url, filePath) {
        return _regeneratorRuntime.async(function _takeScreenshot$(context$2$0) {
            while (1) switch (context$2$0.prev = context$2$0.next) {
                case 0:
                    context$2$0.next = 2;
                    return _regeneratorRuntime.awrap(ensureDir(_path.dirname(filePath)));

                case 2:
                    context$2$0.next = 4;
                    return _regeneratorRuntime.awrap(_testcafeBrowserNatives.screenshot(url, filePath));

                case 4:

                    this.testEntry.hasScreenshots = true;

                    return context$2$0.abrupt('return', filePath);

                case 6:
                case 'end':
                    return context$2$0.stop();
            }
        }, null, this);
    };

    Capturer.prototype.captureAction = function captureAction(_ref) {
        var pageUrl = _ref.pageUrl;
        var stepName = _ref.stepName;
        var customPath = _ref.customPath;
        var fileName, filePath;
        return _regeneratorRuntime.async(function captureAction$(context$2$0) {
            while (1) switch (context$2$0.prev = context$2$0.next) {
                case 0:
                    fileName = Capturer._getFileName(stepName);
                    filePath = customPath ? _path.join(this.testDirPath, customPath, fileName) : _path.join(this.path, fileName);
                    context$2$0.next = 4;
                    return _regeneratorRuntime.awrap(this._takeScreenshot(pageUrl, filePath));

                case 4:
                    return context$2$0.abrupt('return', context$2$0.sent);

                case 5:
                case 'end':
                    return context$2$0.stop();
            }
        }, null, this);
    };

    Capturer.prototype.captureError = function captureError(_ref2) {
        var pageUrl = _ref2.pageUrl;
        var stepName = _ref2.stepName;
        var screenshotRequired = _ref2.screenshotRequired;
        var filePath;
        return _regeneratorRuntime.async(function captureError$(context$2$0) {
            while (1) switch (context$2$0.prev = context$2$0.next) {
                case 0:
                    if (screenshotRequired) {
                        context$2$0.next = 2;
                        break;
                    }

                    return context$2$0.abrupt('return', null);

                case 2:
                    filePath = _path.join(this.path, 'errors', Capturer._getFileName(stepName));
                    context$2$0.next = 5;
                    return _regeneratorRuntime.awrap(this._takeScreenshot(pageUrl, filePath));

                case 5:
                    return context$2$0.abrupt('return', context$2$0.sent);

                case 6:
                case 'end':
                    return context$2$0.stop();
            }
        }, null, this);
    };

    return Capturer;
})();

exports.default = Capturer;
module.exports = exports.default;