'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _indentString = require('indent-string');

var _indentString2 = _interopRequireDefault(_indentString);

function cutTtyColors(str) {
    return str.replace(/\033\[[0-9;]*m/g, '');
}

function rtrim(str) {
    return str.replace(/\s+$/, '');
}

exports.default = function (str, indent, width) {
    var curStr = '';
    var wrappedMsg = '';

    if (cutTtyColors(str).length <= width - indent) return _indentString2.default(str, ' ', indent);

    str = str.replace(/(\r\n)/gm, '\n').split(/(\S+[ \t]+)|(\S+(?:\n))|(\n)/m)
    //NOTE: cut empty elements
    .filter(function (elm) {
        return !!elm;
    });

    str.forEach(function (word) {
        var newStr = curStr + word;

        if (cutTtyColors(newStr).length > width - indent) {
            wrappedMsg += rtrim(curStr) + '\n';
            curStr = word;
        } else {
            if (curStr[curStr.length - 1] === '\n') {
                wrappedMsg += rtrim(curStr) + '\n';
                curStr = '';
            }

            curStr += word;
        }
    });

    return _indentString2.default(wrappedMsg + curStr, ' ', indent);
};

module.exports = exports.default;